package ambient;

import interceptors.FutureCallbackInterceptor;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.control.SuperController;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.juliak.control.interceptor.InterceptorController;

import pda.AmbientInterceptor;
import pda.IAttributeManager;
import pda.IMain;


public class AmbientControllerImpl implements AmbientControllerInterface, Controller,  IAttributeManager {

	
	
	
	// interfaces of components to which the component is bind
	Component ambientController;
	
	/**
	 * client interface
	 */
	InterceptorController iInterceptorController;
	
	/**
	 * client interface
	 */
	BindingController iBindingController;
	
	
		
	//////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////// Bussines code  
	
	
	String[] ambientInterfaces;
	
	
	
	
	
	
	
	
	/**
	 * 
	 */
	public void bindAmbientFc(String service, Object server) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		
		System.out.println("[AmbientController] creating ambient reference!!");
		
		// creating interceptor
		Interceptor myNewInterceptor = (Interceptor) new AmbientInterceptor();
		
		//creating the binding
		bindAmbFc(service,server,myNewInterceptor);
		
		
	}

	
	
	
	
	/**
	 * 
	 */
	public String[] listAmbientFc() {
		
		System.out.println("[_____ Ambient Controller ______] listAMbientFc");
		
		/*
		try {
		
			BindingController bc = (BindingController) ambientController.getFcInterface("iBindingController");
		  System.out.println("__________binding:" + bc.listFc());
			
			
		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		*/
		
		return ambientInterfaces;
	}

	
	
	
	/**
	 * 
	 * 
	 * 
	 */
	public Object lookupAmbientFc(String arg0) throws NoSuchInterfaceException {
		// TODO Auto-generated method stub
		return null;
	}

	
	
	
	
	/**
	 * 
	 * 
	 */
	public void unbindAmbientFc(String service) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		
		//	 obtaining controllers
		BindingController bc = (BindingController) ambientController.getFcInterface("iBindingController");
		
		bc.unbindFc(service);
		
	}

	
  /**
   * @throws NoSuchInterfaceException 
   * 
   * 
   * 
   */
	public void stopAmbientBinding(String service) throws NoSuchInterfaceException {
		
		//	 obtaining controllers
		InterceptorController ic = (InterceptorController) ambientController.getFcInterface("iInterceptorController");
				
		//obtaining the interface
		ComponentInterface itf = (ComponentInterface) getBussinesInterface(service);
		   				
		//	 get interceptor
		Interceptor interceptor = getAmbientInterceptor(ic,itf);
		interceptor.setFcItfDelegate(null);
		
		System.out.println("[_____ Ambient Controller ______] Ambient Binding suspended for the service: " + service);
		
	}

	
	
	/**
	 * reactivates ambient binding which was previously suspended
	 * 
	 * 
	 * @param service
	 * @param server
	 * @throws NoSuchInterfaceException 
	 */
	public void reactivateAmbientBinding(String service, Object serverInterface) throws NoSuchInterfaceException {
		
		//	 obtaining controllers
		InterceptorController ic = (InterceptorController) ambientController.getFcInterface("iInterceptorController");
		ComponentInterface itf = getBussinesInterface(service);
	 	
		// get interceptor
		Interceptor interceptor = getAmbientInterceptor(ic,itf);
		
		//set interceptor
		interceptor.setFcItfDelegate(serverInterface);
		
		
		
	}
	
	
	
  /**
   * @throws NoSuchInterfaceException 
   * @throws IllegalLifeCycleException 
   * @throws IllegalBindingException 
   * 
   * 
   */
	public void futureCallbackBinding(String service, Object server) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		
		System.out.println("[_____ Ambient Controller ______] creating future callback binding!");
		
		// creating interceptor
		Interceptor myNewInterceptor = (Interceptor) new FutureCallbackInterceptor();
		
		bindAmbFc(service,server,myNewInterceptor);
		
	}
	
	
	
	
	
	
	/**
	 * 
	 * 
	 * 
	 * @param service
	 * @param server
	 * @param interceptor
	 * @throws NoSuchInterfaceException
	 * @throws IllegalBindingException
	 * @throws IllegalLifeCycleException
	 */
	private void bindAmbFc(String service, Object server ,Interceptor interceptor) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		
		
		//<TODO> lifeCycleController
		LifeCycleController lc = (LifeCycleController) ambientController.getFcInterface("iLifeCycleController");
		
		//	 obtaining controllers
		BindingController bc = (BindingController) ambientController.getFcInterface("iBindingController");
		InterceptorController ic = (InterceptorController) ambientController.getFcInterface("iInterceptorController");
		
		// the interface of the client component
		ComponentInterface myInterface = getBussinesInterface(service);
	  
		//creating binding
		System.out.println("[_____ Ambient Controller ______] \t Creating binding for service "  + service);
		bc.bindFc(service, server);
		
		ic.addFcInterceptor(myInterface, interceptor);
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/*
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 */
	
	
	
	/**
	 * 
	 * Helping method = just to obtain a bussines interface of the Component
	 * 
	 * @throws NoSuchInterfaceException 
	 * 
	 */
	private ComponentInterface getBussinesInterface(String service) throws NoSuchInterfaceException {
		 
		Component[] sc = ((SuperController) ambientController.getFcInterface("super-controller")).getFcSuperComponents();
		Component comp = (Component) sc[0].getFcInterface("//component");
		ComponentInterface ic = (ComponentInterface) comp.getFcInterface(service);
		
		return ic;
	}
	
	
	
	/**
	 * Retrieves the ambient interceptor from the list of interceptors of the given componetn interface
	 * 
	 * @param ic
	 * @param itf
	 * @return
	 */
	private Interceptor getAmbientInterceptor (InterceptorController ic, ComponentInterface itf ) {
		
		//	obtaining the interceptors
		Interceptor[] interceptorList = ic.getFcInterceptors(itf);
	  // TODO: going through the list of interceptors		
		return interceptorList[0];
	}
	
	
	
	
	
	
	
  /**
   * 
   * 
   * 
   */
	public void initFcController(InitializationContext arg0) throws InstantiationException {
		System.out.println("[_____ Ambient Controller ______]Initializing the Ambient controller");
	}

	
	
	/**
	 * 
	 * 
	 */
	public void setComponent(Component comp) {
		ambientController = comp;
		
	}





	
	
	
	
	

}
