package interceptors;

import java.util.ArrayList;
import java.util.Iterator;

import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;

import ambient.IFutureCallback;

import printer.IPrinter;

public class FutureCallbackInterceptor implements Interceptor, IFutureCallback {

	IFutureCallback delegate; 
	
	/**
	 * list of messages
	 */
	//ArrayList<Future> messages;
	ArrayList messages;
	
	///////////////////////
	

	/**
	 * 
	 */
	public FutureCallbackInterceptor() {
		messages = new ArrayList();
	}
	
	
  /**
  * 
  */
	public void resolveFuture(Future future) {
		if (delegate == null) {
			System.out.println("  [FutureInterceptor] Interface not bind : storing the future into the buffer.");
			messages.add(future);
			
		}
		else {
			System.out.println("  [FutureInterceptor] Interface bind : sending the future.");
			delegate.resolveFuture(future);
			
		}
		
	}

	
	
	
	
	
	
	
	
	
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	
	/**
	 * 
	 */
	public Object getFcItfDelegate() {
		return delegate;
	}

	/**
	 * 
	 */
	public void setFcItfDelegate(Object delegate) {
		this.delegate = (IFutureCallback) delegate; 
  	
  	resolveOldMessages();
	}

	/**
	 * 
	 */
	public void initFcController(InitializationContext arg0) throws InstantiationException {
		// TODO Auto-generated method stub
		
	}
	
	 /**
   * 
   */
	public Object clone() {
    try {
      return super.clone();
    }
    catch( CloneNotSupportedException cnse ) {
    }
    return null;
	}
	
	
	/**
   * 
   *
   */
  private void resolveOldMessages() {
  	if (delegate != null && messages.size() > 0) {
  	
  		System.out.println("[FutureInterceptor] Sending old messages to the Printer.");
  		Iterator iter = messages.iterator();
  		
 		  while(iter.hasNext()) {
 	      Future future = (Future) iter.next();
 	      delegate.resolveFuture(future);
 	    }
 	  }
	}

	
	
}
