package interceptors;

import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;

import pda.IMain;

public class PDALifeCycleInterceptor implements LifeCycleController, IMain, Interceptor {

	public IMain delegate;
	private boolean started;
	private int counter;
	
	
	
	
	
	public String getFcState() {
	   return started ? STARTED : STOPPED;
	}

	public void startFc() throws IllegalLifeCycleException {
		
		System.out.println("[PDA lifecycle] started");
		
		started = true;
		notifyAll();
		
		
		
	}

	public void stopFc() throws IllegalLifeCycleException {
		while (counter > 0) { try { wait(); } catch (InterruptedException _) {} }
	  started = false;
	}
	
	
	
	
	
	public void init() {
		 synchronized (this) {
	      while (counter == 0 && !started) { try { wait(); } catch (InterruptedException _) {} }
	      ++counter;
	    }
	    try {
	    
	    	delegate.init();
	  
	    } finally {
	      synchronized (this) {
	        --counter;
	        if (counter == 0) { notifyAll(); }
	      }
	    }
	} 
	

	
	
	public void main(String[] args) {
		 synchronized (this) {
	      while (counter == 0 && !started) { try { wait(); } catch (InterruptedException _) {} }
	      ++counter;
	    }
	    try {
	    
	    	delegate.main(args);
	  
	    } finally {
	      synchronized (this) {
	        --counter;
	        if (counter == 0) { notifyAll(); }
	      }
	    }
	}

	public Object getFcItfDelegate() {
		return delegate; 
	}

	public void setFcItfDelegate(Object delegate) {
	  this.delegate = (IMain) delegate;
		
	}

	public void initFcController(InitializationContext arg0) throws InstantiationException {
	}
	
	/**
   * 
   */
	public Object clone() {
    try {
      return super.clone();
    }
    catch( CloneNotSupportedException cnse ) {
    }
    return null;
	}

}
