package pda;

import java.util.ArrayList;
import java.util.Iterator;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;

import printer.IPrinter;
import registry.AmbientBinding;
import registry.Service;

public class AmbientInterceptor implements IPrinter, Interceptor {

	/**
	 * delegate
	 */
	private IPrinter delegate;
  
	/**
	 * list of messages
	 */
	//ArrayList<Future> messages;
	ArrayList messages;
	
	//TODO: !!!!!!!!!!!!!   cela tahle trida by mela byt synchronizovana.... proti vice vlaknum
	
	/**
	 * 
	 */
	public AmbientInterceptor() {
		messages = new ArrayList();
	}
	
	/**
	 * @throws NoSuchInterfaceException 
	 * 
	 */
	public String print(String str) throws NoSuchInterfaceException {
		if (delegate == null) {
			System.out.println("  [AmbientInterceptor] Interface not bind : storing messages into the buffer.");
			messages.add(str);
			return null;
		}
		else {
			System.out.println("  [AmbientInterceptor] Interface bind : sending the message.");
			return delegate.print(str);
			
		}
	}

	
	
	/**
	 * 
	 */
	public void init() {}
	
	public void start() {
		// TODO Auto-generated method stub
		
	}

	public void stop() throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		// TODO Auto-generated method stub
		
	}
	
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////// Nonfunctional methods

	/**
	 * 
	 */
  public Object getFcItfDelegate() {
      return delegate;
  }

  /**
   * @return 
   * 
   */
  public synchronized void setFcItfDelegate(Object delegate) {
    
  	this.delegate = (IPrinter) delegate; 
  		
  	
  	try {
			
  		resolveOldMessages();
		
  	
  	} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
  	
  }
  
  /**
   * @throws NoSuchInterfaceException 
   * 
   *
   */
  private void resolveOldMessages() throws NoSuchInterfaceException {
  	if (delegate != null && messages.size() > 0) {
  	
  		System.out.println("[AmbientInterceptor] Sending old messages to the Printer.");
  		Iterator iter = messages.iterator();
  		
 		  while(iter.hasNext()) {
 	      String msg = (String) iter.next();
 	      delegate.print(msg);
 	    }
 	  }
	}

	/**
   * 
   */
  public void initFcController(InitializationContext ic) throws InstantiationException {
  }
	
  /**
   * 
   */
	public Object clone() {
    try {
      return super.clone();
    }
    catch( CloneNotSupportedException cnse ) {
    }
    return null;
	}

		
  
}
