package pda;
import interceptors.Future;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.Type;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;

import ambient.AmbientControllerInterface;
import ambient.IFutureCallback;

import printer.IPrinter;
import registry.IRegistry;
import run.IAmbientController;


/**
 * 
 */




/**
 * @author ales
 *
 */
public class PDAImpl implements IMain, BindingController, IAttributeManager, IFutureCallback, LifeCycleController  {

	
	
	private IPrinter iPrinter;
	
	
	
	private IRegistry iRegistry; 
		
	// reference to a component which is representing this class
	private Component comp;
	
	
	
	public PDAImpl() {
		
		System.out.println("[PDA] Instantiated");
		
		
		
	}
	
	
	public void init() {
		System.out.println("[PDA] Registering to the Registry");
		
		try {
		
			iRegistry.registerService(comp, null,"iPrinter");


		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalBindingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalLifeCycleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 */
	public void main(String[] args) {
	   
		if (args == null ) {
			System.out.println("nothing");
			return;
		}
		
		for (int i =0  ;  i < args.length ; i++) {
		 
			System.out.println("[PDA] sending msg to print.");
			
			
			try {
				
				iPrinter = (IPrinter) comp.getFcInterface("iPrinter");
				iPrinter.print(args[i]); 
				
				
			} catch (NoSuchInterfaceException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
			
			
			
			//iDictionary.dictionary(args[i]);  
	   }
	}

		
	
	
	
	
	
	
  /**
   * 
   */
	public void setComponent(Component comp) {
		this.comp = comp;
		
	}


	
	
	
	/**
	 * 
	 */
	public void resolveFuture(Future future) {
		
		if ( future.getMethod().equals("iPrinter")) {
			resolvePrinting((String) future.getValue());
		}
		
	}
	
	
	
	
	
	
	/**
	 * 
	 * @param str
	 */
	private void resolvePrinting(String str) {
		System.out.println("\t[PDA] ____Future_____ resolved: Printing sucesfully done.");
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	///////////////////////////////////////////////////////
	// 
	//   Nonfunctional methods
		
	
	
	
	
	
	public void setRegistry(IRegistry registry) {
		// TODO Auto-generated method stub
		iRegistry = registry;
	}
	
	
	

	public void bindFc(String cItf, Object sItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		
		
		if (sItf == null) {
			System.out.println("");
		}
		
		if ( cItf.equals("iPrinter")) {
			
			System.out.println("[PDA]........... binding iPrinter");
			
			iPrinter = (IPrinter)sItf;  
		
			
		}
		
		if ( cItf.equals("iRegistry")) {
			iRegistry = (IRegistry)sItf;  
		  }
		
	}

	/**
	 * 
	 */
	public String[] listFc() {
		//System.err.println("===========PDAIMPL............... listing");
		return new String[] { "iPrinter", "iRegister" };
	}

	/**
	 * 
	 */
	public Object lookupFc(String arg0) throws NoSuchInterfaceException {
		if (arg0.equals("iPrinter"))
			return iPrinter;
	    else
	    if (arg0.equals("iRegistry"))
	  		return iRegistry;
	  	else
	  		return null;
	}

	/**
	 * 
	 */
	public void unbindFc(String arg0) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		if ( arg0.equals("iPrinter")) {
			iPrinter = null;
		  }
		
		if ( arg0.equals("iRegistry")) {
			iRegistry = null;
		  }
		
	}


  public IPrinter getIPrinter() {
  	return iPrinter;
  }

  
  
  
  

	public String getFcState() {
		// TODO Auto-generated method stub
		return null;
	}


	public void startFc() throws IllegalLifeCycleException {
		System.out.println("Starting.....");
		
	}


	public void stopFc() throws IllegalLifeCycleException {
		// TODO Auto-generated method stub
		
	}

  







	
	
	
}