package printer;


import interceptors.Future;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

import ambient.IFutureCallback;

import pda.IAttributeManager;

import registry.IRegistry;

public class PrinterImpl implements IPrinter, IAttributeManager, BindingController {

	Component comp;
	
	IRegistry iRegistry;
	
	IFutureCallback iFutureCallback;
	
	
	/**
	 * 
	 *
	 */
	public PrinterImpl()  {
		
    System.out.println("[Printer] Instantiated");
		
		
		
	}
	
	public void init() {
		System.out.println("[Printer] Registering to the Registry");
		
		try {
		
			iRegistry.registerService(comp, "iPrinter", null);


		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalBindingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalLifeCycleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void start() {
		System.out.println("[Printer] Starting again");
		
		try {
		
			iRegistry.registerService(comp, "iPrinter", null);


		} catch (NoSuchInterfaceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalBindingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalLifeCycleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	public void stop() throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		System.out.println("[Printer] Stoping...");

    System.out.println("[Printer] Unconnecting...");
		iRegistry.unregisterProvService(comp);
		System.out.println("[Printer] Unconnected.");
		
	}
	
	/**
	 * @throws NoSuchInterfaceException 
	 * 
	 */
	public String print(String str) throws NoSuchInterfaceException {
		
		//bussines code
		System.out.println("[Printer] printing: "+ str);
		
		
		
		//sending the FUTURE
		IFutureCallback iFutureCallback = (IFutureCallback) comp.getFcInterface("iFutureCallback");
		Future future = new Future("iPrinter","printing is ok");
		iFutureCallback.resolveFuture(future); 
	
		
		return "printing done";
		
	}


	public void setComponent(Component comp) {
		this.comp = comp;
		
	}

	
	


	public void bindFc(String cItf, Object sItf) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		if ( cItf.equals("iRegistry")) {
			iRegistry = (IRegistry)sItf;  
		  }
		
		if ( cItf.equals("iFutureCallback")) {
			iFutureCallback = (IFutureCallback)sItf;  
		  }
		
		
	}

	public String[] listFc() {
		return new String[] { "iRegistry" };
	}

	public Object lookupFc(String arg0) throws NoSuchInterfaceException {
		if (arg0.equals("iRegistry"))
			return iRegistry;
	  
		if (arg0.equals("iFutureCallback"))
			return iFutureCallback;
		
		return null;
	}

	public void unbindFc(String arg0) throws NoSuchInterfaceException, IllegalBindingException, IllegalLifeCycleException {
		if ( arg0.equals("iRegistry")) {
			iRegistry = null;
		  }
		
		if ( arg0.equals("iFutureCallback")) {
			iFutureCallback = null;
		  }
	}

	
}
