package run;



import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.Type;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalContentException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.factory.GenericFactory;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.fractal.juliak.FractalHelper;
import org.objectweb.fractal.juliak.control.membrane.MembraneController;
import org.objectweb.fractal.juliak.membrane.CustomFactory;
import org.objectweb.fractal.juliak.membrane.MPrimitiveImpl;
import org.objectweb.fractal.util.Fractal;

import pda.IAttributeManager;
import pda.IMain;
import printer.IPrinter;
import ambient.AmbientControllerImpl;
import ambient.AmbientControllerInterface;
import ambient.AmbientParametricPrimitive;
import ambient.AmbientPrimitive;



/**
 * 
 * Runs AmbientReferenceExample
 * 
 * Reads AmbientPrimitive membrane definition directly from the AmbientPrimitive.java file. 
 * Does not read .adl file specifying the architecture of the membrane.
 * 
 * Probably there is a bug? when reading the adl definition and thats why its needed to do it directly through the .java class...
 * 
 * @author Ales
 *
 */
public class Runner {

	/**
	 * @param args
	 * @throws InstantiationException 
	 * @throws NoSuchInterfaceException 
	 * @throws IllegalLifeCycleException 
	 * @throws IllegalContentException 
	 * @throws IllegalBindingException 
	 */
	public static void main(String[] args) throws Exception {
		
		
		
		AmbientReferenceExample ex = new AmbientReferenceExample();
		
		
		
		ex.instantiate();
		
		ex.runExample(args);
		
		
		 
	}

	
	
}
