package test;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.factory.GenericFactory;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.juliak.control.interceptor.InterceptorController;
import org.objectweb.fractal.util.Fractal;




public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args)  throws Exception {
		
		
		 Component boot = Fractal.getBootstrapComponent();
     TypeFactory tf = Fractal.getTypeFactory(boot);
     GenericFactory gf = Fractal.getGenericFactory(boot);
     
     /*
      * Create the component type.
      */
     ComponentType cType =
         tf.createFcType(
             new InterfaceType[]{
                 tf.createFcItfType("r", Runnable.class.getName(), false, false, false),
                 tf.createFcItfType("s", Runnable.class.getName(), true, false, false)
             }
         );
     
     ComponentType sType =
       tf.createFcType(
           new InterfaceType[]{
               tf.createFcItfType("s", Runnable.class.getName(), false, false, false)
           }
       );
   
     
     
     
     
     /*
      * Create a primitive component, start it and invoke it.
      */
     Component c = gf.newFcInstance(cType, "primitive", C.class.getName());
     Component s = gf.newFcInstance(sType, "primitive", S.class.getName());
     Component comp = gf.newFcInstance(sType, "composite",null);
     


     //binding
     Fractal.getContentController(comp).addFcSubComponent(c);
     Fractal.getContentController(comp).addFcSubComponent(s);
     Fractal.getBindingController(comp).bindFc("s", c.getFcInterface("r"));
     Fractal.getBindingController(c).bindFc("s", s.getFcInterface("s"));
     
     
     Fractal.getLifeCycleController(comp).startFc();
     ComponentInterface itf = (ComponentInterface) comp.getFcInterface("s");
     ((Runnable)itf).run();
     
     
     
     ComponentInterface clientItf = (ComponentInterface) c.getFcInterface("s");
     
     
     /*
      * Adding an interceptor.
      */
     System.out.println("<< Adding an interceptor");
     InterceptorController ic = (InterceptorController)
         c.getFcInterface("/interceptor-controller");
     Interceptor myInterceptor = new MyInterceptor();
     ic.addFcInterceptor(clientItf, myInterceptor);
     
     /*
      * Re-invoking the component.
      */
     ((Runnable)itf).run();

     
     clientItf = (ComponentInterface) c.getFcInterface("s");
     
     ((Runnable)itf).run();
     
     /*
      * Removing the interceptor.
      */
     //System.out.println("<< Removing the interceptor");
     //ic.removeFcInterceptor(itf, myInterceptor);

     /*
      * Re-invoking the component.
      */
     //((Runnable)itf).run();
		
		
	}

}
